diff --git a/changelog b/changelog
index 1e0a9cf..f491f42 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,5 @@
+20081219 tpd src/axiom-website/patches.html 20081219.01.wxh.patch
+20081219 wxh src/interp/nrunfast.boot Float has exp : Float -> Float
 20081217 tpd src/axiom-website/patches.html 20081217.02.tpd.patch
 20081217 tpd src/input/ndftip.input fix regression on map operation count
 20081217 tpd src/algebra/Makefile remove wtpol.spad
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index b6d0a87..c8f6886 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -819,6 +819,8 @@ bookvol10.3 add domains<br/>
 padic.spad removed<br/>
 <a href="patches/20081217.02.tpd.patch">20081217.02.tpd.patch</a>
 add guess package<br/>
+<a href="patches/20081219.01.wxh.patch">20081219.01.wxh.patch</a>
+Float has exp: Float -> Float<br/>
 
  </body>
 </html>
diff --git a/src/interp/nrunfast.boot.pamphlet b/src/interp/nrunfast.boot.pamphlet
index 7613842..5c1c210 100644
--- a/src/interp/nrunfast.boot.pamphlet
+++ b/src/interp/nrunfast.boot.pamphlet
@@ -779,6 +779,10 @@ newHasTest(domform,catOrAtt) ==
 -- we will refuse to say yes for 'Cat has Cat'
 --GETDATABASE(opOf domform,'CONSTRUCTORKIND) = 'category => throwKeyedMsg("S2IS0025",NIL)
 -- on second thoughts we won't!
+  catOrAtt is [":", fun, ["Mapping", :sig1]] =>
+    evaluateType ["Mapping", :sig1] is ["Mapping", :sig2] =>
+      not(null(HasSignature(domform, [fun, sig2])))
+    systemError '"strange Mapping type in newHasTest"
   GETDATABASE(opOf domform,'CONSTRUCTORKIND) = 'category =>
       domform = catOrAtt => 'T
       for [aCat,:cond] in [:ancestorsOf(domform,NIL),:SUBLISLIS (rest domform,$FormalMapVariableList,GETDATABASE(opOf domform,'ATTRIBUTES))] |  aCat = catOrAtt  repeat
